﻿// actuadores.js

(function(ext) {
    var device = null;
    var _rxBuf = [];
    var switchStatus = {
		On:1,
		Off:0
	};
	var levels = {
		HIGH:1,
		LOW:0
	};
	var estados = {
		prender:1,
		apagar:0,
    ALTO:1,
    BAJO:0,
    "M0":0,
    "M1":1,
    horario:1,
    antihorario:0,
	};


	var values = {};
	var indexs = [];
	var startTimer = 0;
	var versionIndex = 0xFA;
	var responsePreprocessor = {};


	ext.resetAll = function(){
    	device.send([0xff, 0x55, 2, 0, 4]);
    	};

/**************************************************************/
//General porpuse
ext.getDigital = function(pin){
  var deviceId = 30;
  getPackage(0, deviceId, pin);
};
ext.getAnalog = function(pin) {
  var deviceId = 31;
  getPackage(0, deviceId, pin);
};
  ext.getPulse = function(pin,expirar) {
  var deviceId = 37;
  getPackage(0,deviceId,pin,short2array(expirar));
};
ext.runDigital = function(pin, estado) {
  var deviceId = 30;
  runPackage(deviceId, pin, typeof estado=="string"?estados[estado]:new Number(estado));
};
ext.runPwm = function(pin, pwm) {
  var deviceId = 32;
  runPackage(deviceId, pin, pwm);
};
ext.getTimer = function(){
  if(startTimer==0){
    startTimer = new Date().getTime();
  }
  responseValue(0,new Date().getTime()-startTimer);
};
ext.resetTimer = function(){
  startTimer = new Date().getTime();
  responseValue();
};
//Relay
ext.runRelay = function(pin, estado) {
  var deviceId = 104;
  runPackage(deviceId, pin, typeof estado=="string"?estados[estado]:new Number(estado));
};
//DCMotor
ext.beginDCMotor = function(select_motor, pin_EN, pin_IN1, pin_IN2) {
  var deviceId = 105;
  runPackage(deviceId, 1, typeof select_motor=="string"?estados[select_motor]:new Number(select_motor), pin_EN, pin_IN1, pin_IN2);
};
ext.moveDCMotor = function(select_motor, dir, vel) {
  var deviceId = 105;
  runPackage(deviceId, 2, typeof select_motor=="string"?estados[select_motor]:new Number(select_motor), typeof dir=="string"?estados[dir]:new Number(dir), vel);
};
ext.stopDCMotor = function() {
  var deviceId = 105;
  runPackage(deviceId, 3);
};
//Servo Motor
ext.moveServoMotor = function(pin, angulo) {
  var deviceId = 106;
  runPackage(deviceId, pin, angulo);
};
//Stepper Motor
ext.beginStepperMotor = function(pasosPorRev, pin_IN1, pin_IN2, pin_IN3, pin_IN4) {
  var deviceId = 107;
  runPackage(deviceId, 1, short2array(pasosPorRev), pin_IN1, pin_IN2, pin_IN3, pin_IN4);
};
ext.moveStepperMotor = function(pasos, dir, velocidad) {
  var deviceId = 107;
  runPackage(deviceId, 2, short2array(pasos), typeof dir=="string"?estados[dir]:new Number(dir), velocidad);
};
/**************************************************************/





function sendPackage(argList, type){
  var bytes = [0xff, 0x55, 0, 0, type];
  for(var i=0;i<argList.length;++i){
    var val = argList[i];
    if(val.constructor == "[class Array]"){
      bytes = bytes.concat(val);
    }else{
      bytes.push(val);
    }
  }
  bytes[2] = bytes.length - 3;
  device.send(bytes);
}

function runPackage(){
  sendPackage(arguments, 2);
}
function getPackage(){
  var nextID = arguments[0];
  Array.prototype.shift.call(arguments);
  sendPackage(arguments, 1);
}

  var inputArray = [];
var _isParseStart = false;
var _isParseStartIndex = 0;
  function processData(bytes) {
  var len = bytes.length;
  if(_rxBuf.length>30){
    _rxBuf = [];
  }
  for(var index=0;index<bytes.length;index++){
    var c = bytes[index];
    _rxBuf.push(c);
    if(_rxBuf.length>=2){
      if(_rxBuf[_rxBuf.length-1]==0x55 && _rxBuf[_rxBuf.length-2]==0xff){
        _isParseStart = true;
        _isParseStartIndex = _rxBuf.length-2;
      }
      if(_rxBuf[_rxBuf.length-1]==0xa && _rxBuf[_rxBuf.length-2]==0xd && _isParseStart){
        _isParseStart = false;

        var position = _isParseStartIndex+2;
        var extId = _rxBuf[position];
        position++;
        var type = _rxBuf[position];
        position++;
        //1 byte 2 float 3 short 4 len+string 5 double
        var value;
        switch(type){
          case 1:{
            value = _rxBuf[position];
            position++;
          }
            break;
          case 2:{
            value = readFloat(_rxBuf,position);
            position+=4;
          /*  if(value<-255||value>1023){
              value = 0;
            }*/
          }
            break;
          case 3:{
            value = readInt(_rxBuf,position,2);
            position+=2;
          }
            break;
          case 4:{
            var l = _rxBuf[position];
            position++;
            value = readString(_rxBuf,position,l);
          }
            break;
          case 5:{
            value = readDouble(_rxBuf,position);
            position+=4;
          }
            break;
          case 6:
            value = readInt(_rxBuf,position,4);
            position+=4;
            break;
        }
        if(type<=6){
          responseValue(extId,value);
        }else{
          responseValue();
        }
        _rxBuf = [];
      }
    }
  }
  }
function readFloat(arr,position){
  var f= [arr[position],arr[position+1],arr[position+2],arr[position+3]];
  return (parseFloat(f)).toFixed(2);    // Ajuste a 2 decimales despues de la coma
}
function readInt(arr,position,count){
  var result = 0;
  for(var i=0; i<count; ++i){
    result |= arr[position+i] << (i << 3);
  }
  return result;
}
function readDouble(arr,position){
  return readFloat(arr,position);
}
function readString(arr,position,len){
  var value = "";
  for(var ii=0;ii<len;ii++){
    value += String.fromCharCode(_rxBuf[ii+position]);
  }
  return value;
}
  function appendBuffer( buffer1, buffer2 ) {
      return buffer1.concat( buffer2 );
  }

  // Extension API interactions
  var potentialDevices = [];
  ext._deviceConnected = function(dev) {
      potentialDevices.push(dev);

      if (!device) {
          tryNextDevice();
      }
  }

  function tryNextDevice() {
      // If potentialDevices is empty, device will be undefined.
      // That will get us back here next time a device is connected.
      device = potentialDevices.shift();
      if (device) {
          device.open({ stopBits: 0, bitRate: 115200, ctsFlowControl: 0 }, deviceOpened);
      }
  }

  var watchdog = null;
  function deviceOpened(dev) {
      if (!dev) {
          // Opening the port failed.
          tryNextDevice();
          return;
      }
      device.set_receive_handler('arduino',processData);
  };

  ext._deviceRemoved = function(dev) {
      if(device != dev) return;
      device = null;
  };

  ext._shutdown = function() {
      if(device) device.close();
      device = null;
  };

  ext._getStatus = function() {
      if(!device) return {status: 1, msg: 'Board disconnected'};
      if(watchdog) return {status: 1, msg: 'Probing for Board'};
      return {status: 2, msg: 'Board connected'};
  }

  var descriptor = {};
ScratchExtensions.register('CSJB Actuadores', descriptor, ext, {type: 'serial'});
})({});
